/* makeConnect.cc

------
ѹ
------

ver 1.1 2007.11.21 Ω
Plain format V2 ǵҤ줿ƻ֥ǡåȤˤǲήüΤ⤦Ĳ
ߡβƻʬֹä connect2SCF Ѥƻʬ³
ե뤬Plain format V2 ǵҤƤƻ֤˥СƤ
ưʤᡢΤ褦ˤߡβƻʬֹϡPlain format V2
ˤƻʬֹκΤΤ 1 ­ͤȤ

--------------------------------------------------------------------------
 V2 եޥåȥǡ connect եץ
--------------------------------------------------------------------------
*/
// ա makeLakeConnect Ȥ˺ƤΤǡ
//        ץ˰о¤갷ʬ뤬
//        ¼ϵǽʤ


#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAXLENGTH 256

// 饹 MakeConnect 
class MakeConnect {

 protected:
  int* Net_no;                                     /* ƻʬֹ */
  int* Ep_u_no;                                  /* ή¦üֹ */
  int* Ep_d_no;                                  /* ή¦üֹ */
  int* Ep_u_info;                          /* ή¦üΰ־ */
  int* Ep_d_info;                          /* ή¦üΰ־ */
  int* sigma_up;                   /* ήüܤƤƻʬ */
  int* sigma_down;                 /* ή¦ܤƤƻʬ */
  int** mu_up;                 /* ή¦ܤƤƻʬֹ */
  int** mu_down;               /* ή¦ܤƤƻʬֹ */
  int up_inside;                         /* ޳ˤήü */
  int up_online;                             /* վˤήü */
  int down_inside;                       /* ޳ˤ벼ήü */
  int down_online;                           /* վˤ벼ήü */
  int Num_of_Seg;                                    /* ƻʬ */
  int xMapNo;                                       /* Ͽֹ(x) */
  int yMapNo;                                       /* Ͽֹ(y) */
  //int Num_of_Lake_Seg;                             /* дʬ */
  //int* Lake_No;                                   /* дʬֹ*/

 public:
  // 󥹥ȥ饯
  // MakeConnect(char* file_in, char* file_lake_in);
  MakeConnect(char* file_in);
  // plain format V2 ΥǡȤݤͤǼ롣
  //// дֹեɤ߹ߡݡͤǼ롣

  MakeConnect(void){}

  // ǥȥ饯
  ~MakeConnect(void);

 protected:
  void Set_value(void);
  // ѰդͤǼ롣

 //protected:
  //void Set_Lake_value(void);
  // ѰդͤǼ롣

 public:
  void OutputConnectFile
    (
       char* file_out
     );
  // connect եϤ롣

};

// 󥹥ȥ饯
//MakeConnect :: MakeConnect(char* file_in, char* file_lake_in)
MakeConnect :: MakeConnect(char* file_in)
{
  FILE* fp_in;
  //FILE* fp_lake_in;
  char buf[256];
  int n_seg;
  //int n_lake_seg;
  int i;
  //int X, Y, net_no, ep_no, ep_info, lake_no;
  int X, Y, net_no, ep_no, ep_info;

  if((fp_in = fopen(file_in, "r")) == NULL){
    printf("MakeConnect\n");
    printf("Cannot open input file.\n");
    exit(1);
  }

  while(fgets(buf, 256, fp_in) != NULL){
    // Ͽֹ롣
    if(strcmp(buf, "[Map Number]\n") != 0) continue;
    else {
      if(fgets(buf, 256, fp_in) != NULL){
        if(sscanf(buf, "%d %d", &X, &Y) != 2){
          printf("Cannot scan Map Number.\n");
          exit(1);
        }
        xMapNo = X;
        yMapNo = Y;
        break;
      }
    }
  }

  // ƻʬ롣
  while(fgets(buf, 256, fp_in) != NULL){
    if(strcmp(buf, "[Number of River Segments]\n") != 0) continue;
    else {
      if(fgets(buf, 256, fp_in) != NULL){
        if(sscanf(buf, "%d", &n_seg) != 1){
          printf("Cannot scan 'Num_of_Seg'.\n");
          exit(1);
        }
        Num_of_Seg = n_seg;

        /* γ */
        Net_no = new int[Num_of_Seg];
        Ep_u_no = new int[Num_of_Seg];
        Ep_d_no = new int[Num_of_Seg];
        Ep_u_info = new int[Num_of_Seg];
        Ep_d_info = new int[Num_of_Seg];
        sigma_up = new int[Num_of_Seg];
        sigma_down = new int[Num_of_Seg];
        mu_up = new int*[Num_of_Seg];
        mu_down = new int*[Num_of_Seg];
        break;
      }
    }
  }

  /* ͤγǼ */
  while(fgets(buf, 256, fp_in) != NULL){
    // [Data]õ
    if(strcmp(buf, "[Data]\n") != 0) continue;
    else {
      // [Data]ˤ
      i = 0;                      // βƻʬֹ(Net_no[i]i)
      while(fgets(buf, 256, fp_in) != NULL){
        if(i == Num_of_Seg){
          printf("Too many information.\n");
          exit(1);
        }
        if(sscanf(buf, "%d %d %d %d %d",
                        &X, &Y, &ep_no, &net_no, &ep_info) != 5){
          printf("Cannot scan Data.\n");
          exit(1);
        }
        // ƻʬֹǼ
        Net_no[i] = net_no;
        if(ep_no > 0){
          // ή¦ü
          Ep_u_no[i] = ep_no;
          Ep_u_info[i] = ep_info;
        }
        else {
          // ή¦ü
          Ep_d_no[i] = -ep_no;
          Ep_d_info[i] = ep_info;
        }
        // βƻʬΤ⤦üõ
        while(fgets(buf, 256, fp_in) != NULL){
          if(sscanf(buf, "%d %d %d %d %d",
                          &X, &Y, &ep_no, &net_no, &ep_info) != 5){
            printf("Cannot scan Data.\n");
            exit(1);
          }
          if(ep_info == -1) continue;         // ü
          else if(ep_no > 0){
          // ή¦ü
            Ep_u_no[i] = ep_no;
            Ep_u_info[i] = ep_info;
            //  i 򥤥󥯥ȡ
            i++;
            break;
          }

          else{
           // ή¦ü
           Ep_d_no[i] = -ep_no;
           Ep_d_info[i] = ep_info;
           //  i 򥤥󥯥ȡ
           i++;
           break;
          }
        }
      }
    }
  }
  fclose(fp_in);
  Set_value();
}

/*
// makeLakeConnect -> makeConnect ȼѹ
	if((fp_lake_in = fopen(file_lake_in, "r")) == NULL){
		printf("MakeConnection\n");
		printf("Cannot open input file.\n");
		exit(1);
	}
	
	// дʬ
	while(fgets(buf, 256, fp_lake_in) != NULL){
		if(strcmp(buf, "[Number of Lake Segments]\n") != 0) continue;
		else{
			if(fgets(buf, 256, fp_lake_in) != NULL){
				if(sscanf(buf, "%d", &n_lake_seg) != 1){
					printf("Cannot scan 'Num_of_Lake_Seg'.\n");
					exit(1);
				}
				Num_of_Lake_Seg = n_lake_seg;

	//			break;
	//		}
	//	}
	//}
	
	// ͤγǼ
	while(fgets(buf, 256, fp_lake_in) != NULL){
		// [Data]õ
		if(strcmp(buf, "[Data]\n") !=0) continue;
		else{
			// [Data]ˤ
			i = 0;
			while(fgets(buf, 256, fp_lake_in) != NULL){
				if(i == Num_of_Lake_Seg){
					printf("Too many lake segment.\n");
					exit(1);
				}
				if(sscanf(buf, "%d", &lake_no) != 1){
					printf("Cannot scan Lake Data.\n");
					exit(1);
				}
				// о¶ʬֹǼ
				Lake_No[i] = lake_no;
				i++;
			}
		}
		break;	
	}
	}
    Set_Lake_value();
	fclose(fp_lake_in);
*/

// ǥȥ饯
MakeConnect :: ~MakeConnect(void)
{
  delete [] Net_no;
  delete [] Ep_u_no;
  delete [] Ep_d_no;
  delete [] Ep_u_info;
  delete [] Ep_d_info;
  for(int i = 0; i < sigma_up[i]; i++){
    delete [] mu_up[i];
  }
  for(int j = 0; j < sigma_down[j]; j++){
    delete [] mu_down[j];
  }
  delete [] mu_up;
  delete [] mu_down;
  delete [] sigma_up;
  delete [] sigma_down;
//delete [] Lake_No;
}


// sigma, mu ͤǼ޳ξ塦ήüڤӡվξ塦ήü
// 򥫥Ȥ롣
void MakeConnect :: Set_value(void)
{
  int u_counter, d_counter;
  int u_in_counter = 0, d_in_counter = 0;
  int u_on_counter = 0, d_on_counter = 0;
  int i, j;

  up_inside = 0;
  up_online = 0;
  down_inside = 0;
  down_online = 0;

  // sigma_up, sigma_down ͤǼmu_up, mu_down 
  for(i = 0; i < Num_of_Seg; i++){
    u_counter = -1;
    d_counter = -1;
    
    for(j = 0; j < Num_of_Seg; j++){
      if((Ep_u_no[i] == Ep_u_no[j]) || (Ep_u_no[i] == Ep_d_no[j])){
	u_counter++;
      }
      if((Ep_d_no[i] == Ep_u_no[j]) || (Ep_d_no[i] == Ep_d_no[j])){
	d_counter++;
      }
    }
    
    sigma_up[i] = u_counter;
    sigma_down[i] = d_counter;

    if(sigma_up[i] == 0){
      mu_up[i] = new int[1];
    }
    if(sigma_down[i] == 0){
      mu_down[i] = new int[1];
    }
    if(sigma_up[i] != 0){
      mu_up[i] = new int[sigma_up[i]];
    }
    if(sigma_down[i] != 0){
      mu_down[i] = new int[sigma_down[i]];
    }
  }

  // ޳ξ塦ήüڤӡվξ塦ήüο򥫥
  // mu_up, mu_down ͤǼ
  for(i = 0; i < Num_of_Seg; i++){
    if((sigma_up[i] == 0) && (Ep_u_info[i] == 0)){
      // ޳ξήü
      mu_up[i][0] = u_in_counter;
      u_in_counter++;
    }
    if((sigma_down[i] == 0) && (Ep_d_info[i] == 0)){
      // ޳βήü
      mu_down[i][0] = d_in_counter;
      d_in_counter++;
    }
  }
  for(i = 0; i < Num_of_Seg; i++){
    if((sigma_up[i] == 0) && (Ep_u_info[i] != 0)){
      // վξήü
      mu_up[i][0] = u_in_counter + u_on_counter;
      u_on_counter++;
    }
    if((sigma_down[i] == 0) && (Ep_d_info[i] != 0)){
      // վβήü
      mu_down[i][0] = d_in_counter + d_on_counter;
      d_on_counter++;
    }  
  }

  up_inside = u_in_counter;
  up_online = u_on_counter;
  down_inside = d_in_counter;
  down_online = d_on_counter;

  int iup, idown;
  for(i = 0; i < Num_of_Seg; i++){
    iup = 0;
    idown = 0;
    for(j = 0; j < Num_of_Seg; j++){
      if((Ep_u_no[i] == Ep_u_no[j]) && (i != j)){
	// ήüɤ³
	mu_up[i][iup] = -Net_no[j];
	iup++;
      }
      if((Ep_u_no[i] == Ep_d_no[j]) && (i != j)){
	// ήüȲήü³
	mu_up[i][iup] = Net_no[j];
	iup++;
      }
      if((Ep_d_no[i] == Ep_u_no[j]) && (i != j)){
	// ήüȾήü³
	//mu_down[i][idown] = Net_no[j];
	mu_down[i][idown] = -Net_no[j];
	idown++;
      }
      if((Ep_d_no[i] == Ep_d_no[j]) && (i != j)){
	// ήüɤ³
	//mu_down[i][idown] = -Net_no[j];
	mu_down[i][idown] = Net_no[j];
	idown++;
      }
    }
  }
}

/*
// дȸоήԤ
void MakeConnect :: Set_Lake_value(void)
{
	int sigma_down_org;
	int sigma_up_org;
	int i, j, k, l;
	
	// д
	for(i = 0; i < Num_of_Seg; i++){
		for(j = 0; j < Num_of_Lake_Seg; j++){
			if(Net_no[i] == Lake_No[j]){
				// ήʬ -2
				for(k = 0; k < sigma_up[i]; k++){
					mu_up[i][k] = 0;
				}
				sigma_up[i] = -2;
				// ήʬ -2
				for(k = 0; k < sigma_down[i]; k++){
					mu_down[i][k] = 0;
				}
				sigma_down[i] = -2;
			}
		}
	}
	
	// о¤ؤή
	for(i = 0; i < Num_of_Seg; i++){
        // дϹͤʤ
		if(sigma_down[i] != -2){
			sigma_down_org = sigma_down[i];
			// ήʬ -1
			for(k = 0; k < sigma_down_org; k++){
				for(j = 0; j < Num_of_Lake_Seg; j++){
					if(mu_down[i][k] == Lake_No[j] | -mu_down[i][k] == Lake_No[j]){
						sigma_down[i] = -1;
						for(l = 0; l < sigma_down_org; l++){
							mu_down[i][l] = 0;
						}
					}
				}
			}
		}
	}
	
	// о¤ήв
	for(i = 0; i < Num_of_Seg; i++){
        // доήϹͤʤ
		if(sigma_down[i] != -2 && sigma_down[i] != -1){
			sigma_up_org = sigma_up[i];
			// ήʬ -1
			for(k = 0; k < sigma_up_org; k++){
				for(j = 0; j < Num_of_Lake_Seg; j++){
					if(mu_up[i][k] == Lake_No[j]){
						sigma_up[i] = -1;
						for(l = 0; l < sigma_up_org; l++){
							mu_up[i][l] = 0;
						}
					}
				}
			}
		}
	}
}
*/

// ƻʬ³ե롢üֹ-üֹбɽǥåե
// Ϥ롣
void MakeConnect :: OutputConnectFile
(
   char* file_out   // ƻʬ³ե
 )
{
  FILE* fp_out;
  int i, j;
  int num_spll = 0;
  int num_splr = 0;
  int num_rpll = 0;

  fp_out = fopen(file_out, "w");

  fprintf(fp_out, "# %s\n", file_out);
  fprintf(fp_out, "[Number]\n");
//  fprintf(fp_out, "%d\n", Num_of_Seg);
  fprintf(fp_out, "%d\n", Num_of_Seg+1);
  fprintf(fp_out, "[Data]\n");

// ǲü˥ߡβƻʬɲä롣ߡβƻֹϡNet_no[] 
// ֹ 1 礭ͤȤ롣

  int max_Net_no = 0;
  for(i = 1; i < Num_of_Seg; i++){
     if (Net_no[i] > max_Net_no) max_Net_no = Net_no[i];
  }
  max_Net_no++;
  // printf("max_Net_no = %d\n", max_Net_no);
  // 0 ߡ
  fprintf(fp_out, " %d : 1 : %d : 0 : 0 (sp)\n", max_Net_no, Net_no[0]);
  // 1 
  fprintf(fp_out, " %d : %d :", Net_no[0], sigma_up[0]);
  for(j = 0; j < sigma_up[0]; j++){
    fprintf(fp_out, " %d", mu_up[0][j]);
  }
  fprintf(fp_out, " : 1 : %d\n", -max_Net_no);
// ޤɲ

  for(i = 1; i < Num_of_Seg; i++){  // 2ܤϤޤǤƱ
		fprintf(fp_out, " %d : %d :", Net_no[i], sigma_up[i]);
//		fprintf(fp_out, " %d %d", Net_no[i], sigma_up[i]);

    if(sigma_up[i] == 0 || sigma_up[i] == -2){
		fprintf(fp_out, " %d (rp) :", mu_up[i][0]);
//		fprintf(fp_out, " %d", mu_up[i][0]);
    }
    else if(sigma_up[i] == -1){
		num_rpll++;
		fprintf(fp_out, " %d (rpll) :", num_rpll);
//		fprintf(fp_out, " %d", num_rpll);
	}
    else {
      for(j = 0; j < sigma_up[i]; j++){
		fprintf(fp_out, " %d", mu_up[i][j]);
      }
      fprintf(fp_out, " :");
//    fprintf(fp_out, "");

    }

		fprintf(fp_out, " %d :", sigma_down[i]);
//		fprintf(fp_out, " %d", sigma_down[i]);

    if(sigma_down[i] == 0){
		fprintf(fp_out, " %d (sp)\n", mu_down[i][0]);
//		fprintf(fp_out, " %d\n", mu_down[i][0]);

    }
    else if(sigma_down[i] == -1){
		num_splr++;
		fprintf(fp_out, " %d (splr)\n", num_splr);
//		fprintf(fp_out, " %d\n", num_splr);

	}
	else if(sigma_down[i] == -2){
		num_spll++;
		fprintf(fp_out, " %d (spll)\n", num_spll);
//		fprintf(fp_out, " %d\n", num_spll);

	}
    else {
      for(j = 0; j < sigma_down[i]; j++){
	fprintf(fp_out, " %d", mu_down[i][j]);
      }
      fprintf(fp_out, "\n");
    }
  }
  fclose(fp_out);
}

/*
int Set_output_filename
// ϥǡå̾ꤹ롣ϥǡå̾ϥǡå
// κǸ˽ФƤԥꥪɰʹߤ .con ֤ΤȤ롣
// ȤСϥǡå̾
//
//     daidogawa.test-1-1-1.dat
//
// ξ硢ϥǡå̾
//
//     daidigawa.test-1-1-1.con
//
// Ȥʤ롣Ǥ 1 򡢥顼 -1 ֤
(
 char input_filename[],  // ϥǡå̾
 char output_filename[] // ϥǡå̾(Connect file ̾)
 )
{
  int i, n; 
  char string[2];

  // . 鲿ʸܤˤ뤫Ĵ٤롣
  for (i=strlen(input_filename)-1; i >= 0; i--) {  
    string[0] = input_filename[i];
    string[1] = '\0';
//    printf("%d %s\n", i, string);
    n = i;
    if (string[0] == '.') {
      break;
    }
  }
  if (n == 0) { // ϥե̾ . ޤޤƤʤ
    return (-1);
  }
  // ϥǡå̾ꤹ롣
  for (i=0; i <= n; i++) { 
    output_filename[i] = input_filename[i];
  }
  output_filename[i] = '\0';
  strcat(output_filename, "con");
  return (1);
}
*/

/*-------------------------
   ᥤץ
-------------------------*/

int main(
	 int argc,            // θĿ
	 char* argv[]         // ʸ
	 )
{
  if (argc != 1 && argc != 3) {
    //printf("Usage : makeConnect, Plain Format V2, Lake No. File\n");
    printf("Usage : makeConnect, Plain Format V2, Output File.\n");
    printf(" indexFileName\n");
    exit(1);
  }

  char input_filename[MAXLENGTH];   // Plain format V2 Υǡå
  //char input_lake_filename[MAXLENGTH]; // дֹե
  char output_filename[MAXLENGTH];  // ƻʬ³ե

  if (argc == 1){
    printf("# Plain format file : ");
    scanf("%s", input_filename);
    //printf("# Lake No. file : ");
    //scanf("%s", input_lake_filename);
    printf("# Output file : ");
    scanf("%s", output_filename);
  }
  else {
    sscanf(argv[1], "%s", input_filename);
    //sscanf(argv[2], "%s", input_lake_filename);
    sscanf(argv[2], "%s", output_filename);
  }

  // Connect ե̾
  //if (Set_output_filename(input_filename, output_filename) < 0){
  //  printf("Input dataset name is wrong !  Exit program.\n");
  //  exit(1);
  //}

  MakeConnect Test
    (
     input_filename           // V2 format ǡե
     //input_lake_filename      // дֹե
     );

  Test.OutputConnectFile
    (
       output_filename
     );

}
